#2563 closed defect (fixed)

powerpc/ss555: linker script update (add KEEP() sections)

Reported by: Joel Sherrill Owned by: Joel Sherrill
Priority: normal Milestone: Indefinite
Component: bsps Version: 5
Severity: normal Keywords: function sections, KEEP
Cc: Blocked By:
Blocking:

Description

This BSP's linker script does not include KEEP() directives and thus cannot have per-function and per-data element section support enabled.

The preferred solution is to convert the BSP to use a shared base linker script. The acceptable solution is to add the proper KEEP directives to the existing linker script(s).

Shared linker scripts for the arm, m68k, and sparc have the proper KEEP sections and can serve as examples.

Change History (5)

comment:1 Changed on Feb 15, 2017 at 1:49:47 PM by Sebastian Huber

Owner: set to Joel Sherrill
Status: newassigned

comment:2 Changed on May 11, 2017 at 7:31:02 AM by Sebastian Huber

Milestone: 4.124.12.0

comment:3 Changed on Aug 24, 2017 at 5:59:58 AM by Sebastian Huber

Milestone: 4.12.0Indefinite

comment:4 Changed on Sep 14, 2018 at 6:57:42 PM by Joel Sherrill

Keywords: function sections KEEP added

comment:5 Changed on Nov 30, 2018 at 3:25:55 PM by Shashvat Jain <shashvatjain2002@…>

Resolution: fixed
Status: assignedclosed

In 8b6273a8/rtems:

powerpc/ss555:Add per-section compilation and linking support(GCI 2018)

The size of the sample executables without this option were:

text data bss dec hex filename

116512 1340 15400 133252 20884 ./base_sp.exe
246172 2328 18324 266824 41248 ./capture.exe
319368 3520 16496 339384 52db8 ./cdtest.exe

1077464 22428 23284 1123176 112368 ./cxx_iostream.exe

640632 4916 28408 673956 a48a4 ./fileio.exe
148844 1692 15572 166108 288dc ./hello.exe
328648 6252 22408 357308 573bc ./loopback.exe

95828 1196 12224 109248 1aac0 ./minimum.exe

145576 1872 15528 162976 27ca0 ./nsecs.exe
194932 2100 16172 213204 340d4 ./paranoia.exe
537060 12460 45124 594644 912d4 ./pppd.exe
119620 1380 15464 136464 21510 ./ticker.exe
119388 1324 19300 140012 222ec ./unlimited.exe

The size of the sample executables with this option were:

text data bss dec hex filename

235000 2336 16628 253964 3e00c ./cxx_iostream.exe
627252 4892 28108 660252 a131c ./fileio.exe
137648 1676 15528 154852 25ce4 ./hello.exe
308616 6236 22336 337188 52524 ./loopback.exe

89564 1180 12144 102888 191e8 ./minimum.exe

137184 1856 15432 154472 25b68 ./nsecs.exe
184264 2084 16144 202492 316fc ./paranoia.exe
520768 12440 45020 578228 8d2b4 ./pppd.exe
113260 1364 15356 129980 1fbbc ./ticker.exe
117236 1308 19272 137816 21a58 ./unlimited.exe
110584 1324 15308 127216 1f0f0 ./base_sp.exe
229172 2316 18288 249776 3cfb0 ./capture.exe
233980 2320 16436 252736 3db40 ./cdtest.exe

Closes #2563

Note: See TracTickets for help on using tickets.